package Level2;

import java.util.Hashtable;
import java.util.ArrayList;


/**
 * Created by IntelliJ IDEA.
 * User: Patricia
 * Date: May 30, 2004
 * Time: 2:18:15 PM
 * To change this template use File | Settings | File Templates.
 */
public class GroupHandler {

    public static Hashtable groups = new Hashtable();

    public static void handleRequest(String group, String clientServerUrl, String event)
    {

       System.out.println("event is ... " + event);
       String [] attributes = event.split(";");
       String action = null;
       String userName = null;
       String userId = null;
       String displayUrl = null;
       GroupInfo groupInfo = (GroupInfo)groups.get(group);
       System.out.println("In handleRequest");



       for (int i=0; i<attributes.length; i++)
       {
          String[] pairs = attributes[i].split("=");
          if (pairs[0].equals("event"))
          {
                action = pairs[1];
                System.out.println("action:" + action);
          }
       }
       if (action.equals("status"))
       {
          for (int i=0; i<attributes.length; i++)
          {
                String[] pairs = attributes[i].split("=");
                if (pairs[0].equals("name"))
                {
                     userName = pairs[1];
                }
                if (pairs[0].equals("id"))
                {
                     userId = pairs[1];
                }
           }

           if (groupInfo == null)
           {
                groupInfo = new GroupInfo(group);
                groups.put(group, groupInfo);
           }
           User user = new User(group,  clientServerUrl, userName, userId);
           groupInfo.addUser(user);

           sendToClientServers(group, event);


       }
       else if (action.equals("logOff"))
       {

          sendToClientServers(group, event);
          for (int i=0; i<attributes.length; i++)
          {
                String[] pairs = attributes[i].split("=");
                if (pairs[0].equals("serverLogin"))
                {
                     userName = pairs[1];
                }
                if (pairs[0].equals("serverId"))
                {
                     userId = pairs[1];
                }
           }

           if (groupInfo !=null)
           {
               User user = new User(group,  clientServerUrl, userName, userId);
               groupInfo.removeUser(user);
               if (groupInfo.isGroupEmpty())
                   groups.remove(group);
           }
       }
       else if (action.equals("url"))
       {
           sendToClientServers(group, event);
           for (int i=0; i<attributes.length; i++)
           {
                String[] pairs = attributes[i].split("=");
                if (pairs[0].equals("value"))
                {
                    displayUrl = pairs[1];
                }
           }
           if (groupInfo !=null)
               groupInfo.updateUrlForGroup(displayUrl);

       }
        else
       {
           sendToClientServers(group, event);
       }

    }


    public static void sendToClientServers(String group, String event)
    {

       GroupInfo groupInfo = (GroupInfo)groups.get(group);

       if (groupInfo!=null)
       {
          (new ClientServerHandler()).send(groupInfo.getClientServers(), group, event);
       }
    }


    public static String getUrl(String group)
    {

        GroupInfo groupInfo = (GroupInfo)groups.get(group);
        if (groupInfo== null)
            return null;
        else
            return groupInfo.getUrl();

    }

    public static ArrayList getUsers(String group)
    {

        GroupInfo groupInfo = (GroupInfo)groups.get(group);
        if (groupInfo== null)
            return null;
        else
            return groupInfo.getUsers();

    }


}
