package LoadBalance;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.sql.ResultSet;


/**
 * Created by IntelliJ IDEA.
 * User: pferrao
 * Date: May 6, 2004
 * Time: 1:59:54 PM
 * To change this template use Options | File Templates.
 */
public class LoadBalanceTag  extends TagSupport
{

	String groupID;
	String loginName;
	String groupPassword;
    

    public void setGroupID(String groupID)
    {
        this.groupID = groupID;
    }

    public void setLoginName(String loginName)
    {
        this.loginName = loginName;
    }

    public void setGroupPassword(String groupPassword)
    {
        this.groupPassword = groupPassword;
    }

    synchronized private String getClientServer()
        throws Exception
    {

      Statement stmt=null;
      ResultSet rs = null;
      String url = null;
      Connection conn = null;

      try {
         conn = getDbConnection();


         stmt = conn.createStatement();
         rs = stmt.executeQuery("SELECT url FROM servers where usageLoad = 'LOW' order by lastUsed limit 1");
         if (rs.next())
         {
              url = rs.getString("url");
              stmt.close();
              rs.close();

         }
         else
         {
             stmt = conn.createStatement();
             rs = stmt.executeQuery("SELECT url FROM servers where usageLoad = 'MEDIUM' order by lastUsed limit 1");
             if (rs.next())
             {
                 url = rs.getString("url");
                 stmt.close();
                 rs.close();
             }
             else
             {

                stmt = conn.createStatement();
                rs = stmt.executeQuery("SELECT url FROM servers order by lastUsed limit 1");
                if (rs.next())
                {
                    url = rs.getString("url");
                    stmt.close();
                    rs.close();
                }
             }

         }

         if (url!=null)
         {
            if (stmt!=null)
                stmt.close();
            if (rs!=null)
                rs.close();

            stmt = conn.createStatement();
            stmt.executeUpdate("UPDATE servers set lastUsed = concat(curdate(), ' ', curtime()) where url = '" + url + "'");
            stmt.close();
        }

      }
      catch (Exception e){
        e.printStackTrace();
        throw e;
      }
      finally {
        if (conn!=null)
            conn.close();

        if (stmt != null)
            stmt.close();

        if (rs!=null)
            rs.close();
      }

      return url;
    }


    private String verifyLogin(String groupId, String password)
        throws Exception
    {

        Connection  conn = null;
        Statement stmt=null;
        ResultSet rs = null;
        String backUrl = null;
        try {
            conn = getDbConnection();
            if (groupId !=null && password!=null)
            {
                stmt = conn.createStatement();
                rs = stmt.executeQuery("Select * from groups where groupId = '" + groupId + "' and password = '" + password + "'");
                if (rs.next())
                {
                    backUrl = rs.getString("level2URL");

                }
                else
                {
                    stmt.close();
                    rs.close();
                    stmt = conn.createStatement();
                    rs = stmt.executeQuery("Select * from groups where groupId = '" + groupId + "'");
                    if (!rs.next())
                    {

                        stmt.close();
                        rs.close();
                        stmt = conn.createStatement();
                        stmt.executeUpdate("Insert into groups values ('" + groupId + "', '" + password + "', 'crestone.uccs.edu:8289')");
                        backUrl = "crestone.uccs.edu:8289";
                    }
                    else
                    {
                        throw new Exception ("Login not valid") ;
                    }
                }
            }

        }

        catch (Exception e)
        {
            e.printStackTrace();
            throw (e);
        }
        finally{
            if (conn!=null)
                conn.close();
            if (stmt!=null)
                stmt.close();
            if (rs!=null)
                rs.close();
        }


        return backUrl;
    }

    public Connection getDbConnection()
     throws Exception
    {

            Connection conn = null;

            try
            {
                Class.forName("com.mysql.jdbc.Driver");
                conn =  DriverManager.getConnection("jdbc:mysql://sanluis.uccs.edu/pferraodb?user=pferrao&password=p2004ferrao", null, null);
                if (conn!=null)
                    System.out.println("a DB connection has been established");
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw e;
            }
         return conn;
    }



	public int doStartTag()
	{
		try {
			JspWriter out = pageContext.getOut();
            // getDbConnection();
            //String clientServer = getClientServer();
            String valid = verifyLogin(this.groupID, this.groupPassword);
            if (valid != null)
            {
                String clientServer = getClientServer();
                System.out.println("Going to " + clientServer + " backend is : "  + valid);

                out.print("http://" + clientServer + "/CoWebBrowseProj/html/signdir/Login.jsp?groupID='" + this.groupID +"'&loginName='" + this.loginName + "'&groupPassword='" + this.groupPassword + "'&level2Url='" + valid + "'");

            }
            else
            {
               System.out.println("Login not valid!!! " + this.groupID + ":" + this.groupPassword);
               //print error page URL
            }
			//out.print("http://sanluis.uccs.edu:8289/CoWebBrowseProj/html/signdir/Login.jsp?groupID='" + this.groupID +"'&loginName='" + this.loginName + "'&groupPassword='" + this.groupPassword + "'");
		}
		catch(Exception ioe){
			System.out.println("Error generating login parms");
		}

		return (SKIP_BODY);
	}

}
