
/**
 * Created by IntelliJ IDEA.
 * User: Patricia
 * Date: Mar 7, 2004
 * Time: 5:37:16 PM
 * To change this template use File | Settings | File Templates.
 */

// Copyright (c) 2000 Just Objects B.V. <just@justobjects.nl>
// Distributable under LGPL license. See terms of license at gnu.org.



    /**
     * Abstract Event source from which Events are pulled.
     *
     * @version $Id: EventSource.java,v 1.3 2003/08/15 08:37:40 justb Exp $
     * @author Just van den Broecke - Just Objects &copy;
     **/

    /** Interface for specifc Event(Pull/Push)Sources. */
    public interface EventSource {
            /** Activate the event source. */
            public void activate();

            /** Deactivate the event source. */
            public void passivate();
    }


/*
  * $Log: EventSource.java,v $
  * Revision 1.3  2003/08/15 08:37:40  justb
  * fix/add Copyright+LGPL file headers and footers
  *
  * Revision 1.2  2003/05/18 16:15:08  justb
  * support for XML encoded Events
  *
  * Revision 1.1.1.1  2002/09/24 21:02:31  justb
  * import to sourceforge
  *
  * Revision 1.1.1.1  2002/09/20 22:48:17  justb
  * import to SF
  *
  * Revision 1.1.1.1  2002/09/20 14:19:03  justb
  * first import into SF
  *
  * Revision 1.3  2002/04/15 20:42:41  just
  * reformatting and renaming GuardedQueue to BlockingQueue
  *
  * Revision 1.2  2000/08/21 20:48:29  just
  * added CVS log and id tags plus copyrights
  *
  *
  */



