package Level2;

import java.util.ArrayList;
import java.util.Iterator;
import java.net.URL;
import java.net.URLConnection;
import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Created by IntelliJ IDEA.
 * User: Patricia
 * Date: May 30, 2004
 * Time: 2:32:16 PM
 * To change this template use File | Settings | File Templates.
 */
public class ClientServerHandler {

    public void send(ArrayList clientServers, String group, String event)
    {
       Iterator itr = clientServers.iterator();

       while (itr.hasNext())
       {
           sendToClientServer((String) itr.next(), group, event);
       }
    }

    private void sendToClientServer(String url, String group, String event)
    {
       try {
         URL urlConn = new URL("http://" + url + "/CoWebBrowseProj/acceptFromLevel2");
         URLConnection connection = urlConn.openConnection();
         connection.setDoOutput(true);
         connection.setDoInput(true);


         PrintWriter out = new PrintWriter(
                              connection.getOutputStream());
         long time = System.currentTimeMillis();
         System.out.println("sending to : " + url +  " time : " + time);
	     out.write("Group=" + group + "&Event=" + event);
         out.flush();
	     out.close();

          BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                connection.getInputStream()));
        String inputLine;

        while ((inputLine = in.readLine()) != null)
            System.out.println(inputLine);


	    in.close();
       }
       catch (Exception e)
       {
           System.out.println("Unable to send event: " + event + " to " + url);
           e.printStackTrace();
       }
    }
}
