
/**
 * Created by IntelliJ IDEA.
 * User: Patricia
 * Date: Mar 7, 2004
 * Time: 5:49:25 PM
 * To change this template use File | Settings | File Templates.
 */
// Copyright (c) 2000 Just Objects B.V. <just@justobjects.nl>
// Distributable under LGPL license. See terms of license at gnu.org.




import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * Servlet that creates and runs PushletSubscriber per request.
 *
 * @version $Id: Pushlet.java,v 1.2 2003/08/15 08:37:40 justb Exp $
 * @author Just van den Broecke - Just Objects &copy;
 */
public class Pushlet extends HttpServlet {

        /** Servlet GET request: instantiates PushletSubscriber per request. */
        public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
               System.out.println("!!!!!!!!Got a request inside Pushlet!!!!!!!!!! : ");
                try {
                        PushletSubscriber pushletSubscriber = new PushletSubscriber();
                        pushletSubscriber.init(request, response);

                        // Loops until connection closed by client


                        pushletSubscriber.processEvents();
                } catch (IOException ioe) {
                      System.out.println("Pushlet: IOException in doGet()");
                }
        }
}

/*
 * $Log: Pushlet.java,v $
 * Revision 1.2  2003/08/15 08:37:40  justb
 * fix/add Copyright+LGPL file headers and footers
 *
 * Revision 1.1  2003/08/13 13:26:57  justb
 * moved all servlets to servlet package
 *
 * Revision 1.2  2003/05/18 16:15:08  justb
 * support for XML encoded Events
 *
 * Revision 1.1.1.1  2002/09/24 21:02:32  justb
 * import to sourceforge
 *
 * Revision 1.1.1.1  2002/09/20 22:48:18  justb
 * import to SF
 *
 * Revision 1.1.1.1  2002/09/20 14:19:04  justb
 * first import into SF
 *
 * Revision 1.3  2002/04/15 20:42:41  just
 * reformatting and renaming GuardedQueue to BlockingQueue
 *
 * Revision 1.2  2000/08/21 20:48:29  just
 * added CVS log and id tags plus copyrights
 *
 *
 */

